                .286
                .Model  Small, PASCAL
                Jumps
                Smart
                Locals
                .Stack
                .Code

BeginOfProgram:

;; 
AllocMem        Macro   BlockSize
                Mov     BX,BlockSize
                Mov     AH,048h
                Int     021h
                EndM
;; 
@StartUp:
                Mov     AX,ES
                Mov     BX,LastSeg
                Sub     BX,AX
                Mov     AH,04Ah
                Int     021h

                Mov     AX,CS
                Mov     DS,AX
                Mov     ES,AX
                CLD

;; 뤥 ⥬  ...
                AllocMem       01000h
                JC      @@NoMemory
                Mov     SystemMemorySeg,AX

;; ⥭ 誨 -86   ($F800..$FFFF) ...
                Mov     DX,Offset BIOSfilename
                Mov     AX,03D00h
                Int     021h
                JNC     @@FileOk
                Mov     DX,Offset Msg_FileError
                Jmp     @@PrintAndExit
@@FileOk:
                Mov     BX,AX
                Xor     DX,DX
                Mov	Ax,SystemMemorySeg
		Mov	Ds,Ax
		Mov	Dx,0F800h
                Mov     CX,08000h
                Mov     AH,03Fh
                Int     021h
                JNC     @@ReadOk
                Mov     DX,Offset Msg_ReadError
                Jmp     @@PrintAndExit
@@ReadOk:
                Mov     AH,03Eh
                Int     021h

		Mov	Ax,0003	; 樠㥬 ⥪⮢ ࠭ 80x25
		Int	10h

                Mov     AX,CS
                Mov     DS,AX

;                xor	ax,ax
;                mov	es,ax
;                mov     ax,es:[36]
;                mov     cs:kbd_36,ax
;                mov     ax,es:[38]
;                mov     cs:kbd_38,ax

                Call    InitTimer	; . ⠩  ॣ樨 ࠭
                Call    TranslZ80	;  㠫쭮 
                Call    ResetTimer	; ⠭ ० 祭 ⠩
                mov     ax,0003
                int     10h
                Mov     AX,04C00h
                Int     021h
;; 
@@NoMemory:
                Mov     DX,Offset Msg_NoMemory
@@PrintAndExit:
                Mov     AH,9
                Int     021h
                Mov     AX,04C00h
                Int     021h
                EndP
;; 
BIOSfilename    DB      'RK86.ROM',0
;; 
Msg_NoMemory    DB      'Not enough memory.',10,13,'$'
Msg_FileError   DB      'File RK86.ROM not found.',10,13,'$'
Msg_ReadError   DB      'File RK86.ROM read error.',10,13,'$'
;; 
LastSeg         DW      Seg ZZZZZ

ZZZZZ           Segment
ZZZZZ           EndS

                INCLUDE ZIL.INC

EndOfProgram:
                END
